// walkthrogh.c
//  3D֤֤Τ褦˰ư
//
//- Jan 31 2003 ----------------------------------

#include <GL/glut.h>
#include <math.h>

GLuint objects;  // ǥץ쥤ꥹֹ
#define RadToDeg 0.01753  // 1٤Ф1饸

int ww, hh;
double theta = 0.0;
double V = 0.0;  // ʹФ®
double t = 0.0;  // 

void display(void)
{
  static GLfloat lightpos[] = { 3.0, 4.0, 5.0, 1.0 }; /* ΰ */
  static double ex = 0.0, ez = 0.0;  // ΰ
  static double Vx = 0.0, Vz = 0.0;  // ®٥٥ȥ
  static double r = 0.0;             // θ

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  
  r += theta * t;

  if( r < 0 ){
    Vx = V * sin(fabs(r) * RadToDeg);
    Vz = V * cos(fabs(r) * RadToDeg);
  }else{
    Vx = -V * sin(fabs(r) * RadToDeg);
    Vz =  V * cos(fabs(r) * RadToDeg);
  }

  ex += Vx * t;
  ez += Vz * t;
  
  glRotated(r, 0.0, 1.0, 0.0);  // ž
  glTranslated(ex, 0.0, ez);    // ư

  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);  // ΰ
  glCallList(objects);  // 

  glutSwapBuffers();
}

void resize(int w, int h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 1.0, 1000.0);
  glMatrixMode(GL_MODELVIEW);
  ww = w; hh = h;  // ̥Ǽ
}

void idle()
{
  t += .01;  // ַв
  glutPostRedisplay();
}

void motion(int x, int y)
{
  // ϥɥڤ
  if(x < ww/2) theta = -(fabs(0.5*ww - x ) / (0.5*ww)) * 2.;
  if(x > ww/2) theta =  (fabs(0.5*ww - x ) / (0.5*ww)) * 2.;

  // ԡ
  if(y < hh/2) V =  fabs(0.5*hh - y)/2000;
  if(y > hh/2) V = -fabs(0.5*hh - y)/3000;  // Хåʤ٤
}


void keyboard(unsigned char key, int x, int y)
{
  if(key == '\033' || key == 'q') exit(0);  // ESC  q ǽλ
}

void scene(void)
{
  /* ʪΤο */
  static GLfloat red[] = { 0.8, 0.2, 0.2, 1.0 };
  static GLfloat green[] = { 0.2, 0.8, 0.2, 1.0 };
  static GLfloat blue[] = { 0.2, 0.2, 0.8, 1.0 };
  static GLfloat yellow[] = { 0.8, 0.8, 0.2, 1.0 };
  static GLfloat ground[][4] = {
    { 0.6, 0.6, 0.6, 1.0 },
    { 0.3, 0.3, 0.3, 1.0 }
  };

  int i, j;

  /* ޷ǥץ쥤ꥹȤϿ */
  objects = glGenLists(1);
  glNewList(objects, GL_COMPILE);

  /* ֤Ȣ */
  glPushMatrix();
  glTranslated(0.0, 0.0, -6.0);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, red);
  glutSolidCube(1.0);
  glPopMatrix();

  /* ФȢ */
  glPushMatrix();
  glTranslated(0.0, 0.0, 6.0);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, green);
  glutSolidCube(1.0);
  glPopMatrix();

  /* ĤȢ */
  glPushMatrix();
  glTranslated(-6.0, 0.0, 0.0);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, blue);
  glutSolidCube(1.0);
  glPopMatrix();

  /* Ȣ */
  glPushMatrix();
  glTranslated(6.0, 0.0, 0.0);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, yellow);
  glutSolidCube(1.0);
  glPopMatrix();

  /*  */
  glBegin(GL_QUADS);
  glNormal3d(0.0, 1.0, 0.0);
  for (j = -20; j < 20; j++) {
    for (i = -20; i < 20; i++) {
      glMaterialfv(GL_FRONT, GL_DIFFUSE, ground[(i + j) & 1]);
      glVertex3d((GLdouble)i, -0.5, (GLdouble)j);
      glVertex3d((GLdouble)i, -0.5, (GLdouble)(j + 1));
      glVertex3d((GLdouble)(i + 1), -0.5, (GLdouble)(j + 1));
      glVertex3d((GLdouble)(i + 1), -0.5, (GLdouble)j);
    }
  }
  glEnd();

  glEndList();
}

void init(void)
{
  /*  */
  glClearColor(1.0, 1.0, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
}

int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
  glutInitWindowSize(600, 600);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);

  glutIdleFunc(idle);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  scene();
  init();
  glutMainLoop();
  return 0;
}
